Index: src/backend/commands/tablecmds.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/commands/tablecmds.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.8.22
diff -c -r1.1.1.2 -r1.1.1.2.8.22
*** src/backend/commands/tablecmds.c	1 Dec 2008 09:37:46 -0000	1.1.1.2
--- src/backend/commands/tablecmds.c	19 Mar 2009 12:34:56 -0000	1.1.1.2.8.22
***************
*** 4061,4066 ****
--- 5523,5532 ----
  	List	   *children;
  	ObjectAddress object;
  
+ 	/* Check if the column is part of any partition key. */
+ 	if( GetPartitionsCountAtt(RelationGetRelid(rel), get_attnum(RelationGetRelid(rel), colName)) > 0)
+ 		elog(ERROR, "Can not drop column '%s' as this is part of partition key of '%s' table.", colName, RelationGetRelationName(rel));
+ 
  	/* At top level, permission check was done in ATPrepCmd, else do it */
  	if (recursing)
  		ATSimplePermissions(rel, false);
***************
*** 5557,5562 ****
--- 7023,7032 ----
  	SysScanDesc scan;
  	HeapTuple	depTup;
  
+ 	/* Check if the column is part of any partition key. */
+ 	if( GetPartitionsCountAtt(RelationGetRelid(rel), get_attnum(RelationGetRelid(rel), colName)) > 0)
+ 		elog(ERROR, "Can not alter column '%s' as this is part of partition key of '%s' table.", colName, RelationGetRelationName(rel));
+ 
  	attrelation = heap_open(AttributeRelationId, RowExclusiveLock);
  
  	/* Look up the target column */
***************
*** 7764,7767 ****
--- 9234,9870 ----
  			cur_item = lnext(prev_item);
  		}
  	}
+ }
+ 
+ 
+ /* 
+  * ------------------------------------------------------------------------------
+  *	DefinePartitions
+  *	Create new partitions. They end up inheriting from the parent
+  *	relation.
+  *	Once they have been created, triggers need to be assigned to the parent to
+  *	provide the UPDATEs/INSERTs/DELETEs to percolate down to the children
+  * 	Callers expect this function to end with CommandCounterIncrement if it
+  * 	makes any changes.
+  * ------------------------------------------------------------------------------
+  */
+ void
+ DefinePartitions(CreateStmt *stmt, Oid parentRelId)
+ {
+ 	CreateStmt		*childStmt;
+ 	RangeVar 		inr;
+ 	Oid 			childOid;
+ 	PartitionAttrs	*partAttr;
+ 	int 			*partKeyOrder;
+ 	List			*partColumnList;
+ 	ListCell		*partColumn;
+ 	int 			count, i, j;
+ 	List			*columnList;
+ 	ListCell		*column;
+ 	StringInfo  	childTableName = makeStringInfo();
+ 	Oid				*partitionRelOids;
+ 	bool			partitionColumnMatch;
+ 	Relation    	rel;
+ 	StringInfo  	createTrigger = makeStringInfo();
+ 	List        	*query_list;
+ 	Node        	*parsetree;
+ 	
+ 
+ 	/* If no partitions are defined then return. */
+ 	if (stmt->partAttr == NULL) 
+ 		return;
+ 	
+ 	partColumnList = ((PartitionAttrs *)(stmt->partAttr))->colName;
+ 
+ 	i = 0;
+ 	j = 0;
+ 	partitionColumnMatch = false;
+ 
+ 	Assert(IsA(stmt->partAttr, PartitionAttrs));
+ 
+ 	partAttr = (PartitionAttrs *)(stmt->partAttr);
+ 	/* To store the partition key order */
+ 	partKeyOrder = malloc(partColumnList->length * sizeof(int));
+ 	columnList 	= stmt->tableElts;
+ 
+ 	foreach(partColumn, partColumnList)
+ 	{
+ 		/* Get the name of partition key column. */
+ 		char *colName = ((Alias *)lfirst(partColumn))->aliasname;
+ 		count = 0;
+ 
+ 		foreach(column, columnList)
+ 		{
+ 			ColumnDef *tmp = lfirst(column);
+ 			count++;
+ 			if(strcmp(tmp->colname, colName) == 0)
+ 			{
+ 				partKeyOrder[j++] = count;
+ 				partitionColumnMatch = true;
+ 				break;
+ 			}
+ 		}
+ 		if(partitionColumnMatch == false)
+ 			elog(ERROR, "'%s' attribute is not present in given table.", colName);
+ 	}
+ 
+ 	/*
+ 	 * All the partitions will inherit from the parent, set the parent in the
+ 	 * inhRelations structure
+ 	 */
+ 	inr = *stmt->relation;
+ 
+ 	/* 
+ 	 * Create the children tables. The parser has already made sure that we
+ 	 * have atleast one partition in the list
+ 	 */
+ 	if (partAttr->partFunc == PART_LIST || partAttr->partFunc == PART_RANGE)
+ 	{
+ 		List 		*partitionList = partAttr->partitions;
+ 		ListCell 	*temp_part; 
+ 		int			isSystemGeneratedName = 0;
+ 		int 		isUserGeneratedName = 0;
+ 		int			i = 0;
+ 
+ 		Assert(list_length(partitionList) > 0);
+ 
+ 		rel = RelationIdGetRelation(parentRelId);
+ 		resetStringInfo(createTrigger);
+ 		appendStringInfo(createTrigger, "CREATE TRIGGER zz_partition_insert_trigger BEFORE INSERT ON %s ", RelationGetRelationName(rel));
+ 		appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_insert_trigger();");
+ 		relation_close(rel, 0);
+ 
+ 		/* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+ 		query_list  = pg_parse_query(createTrigger->data);
+ 		parsetree = (Node *)lfirst(list_head(query_list));
+ 		CreateTrigger((CreateTrigStmt * )parsetree, 0);
+ 
+ 		/* To avoid tuple being updated by the current transaction, after the current scan started */
+ 		CommandCounterIncrement();
+ 	
+ 		/* Allocate the storage for number of partitions.*/
+ 		partitionRelOids = malloc(sizeof(Oid)*list_length(partitionList));
+ 
+ 		foreach(temp_part, partitionList)
+ 		{
+ 			Partition *temp_partition = lfirst(temp_part);
+ 			/*
+ 			 * Create a working copy for each child
+ 			 */
+ 			childStmt = (CreateStmt *)copyObject((void *)stmt);
+ 			childStmt->constraints = list_make1(temp_partition->partitionCheck);
+ 
+ 			/*
+ 			 * Child has to use all columns from the parent, otherwise we will get
+ 			 * unnecessary merging columns notices as part of the
+ 			 * DefineRelation 
+ 			 */	
+ 			childStmt->tableElts = NIL;
+ 				
+ 			childStmt->inhRelations = lappend(NULL, &inr);
+ 
+ 			/* If partition name is not specified then generate one and apply. */
+ 			if(temp_partition->partName == NULL)
+ 			{
+ 
+ 				if(isUserGeneratedName == 1)
+ 					elog(ERROR, "Combination of user generated and system generated table names is not allowed.");				
+ 
+ 				isSystemGeneratedName = 1;
+ 				i++;
+ 
+ 				appendStringInfo(childTableName, "%s_%d", stmt->relation->relname, i);
+ 
+ 				/* Assign the child table name. */        
+ 				childStmt->relation->relname = childTableName->data;			
+ 
+ 				temp_partition->partName = makeNode(RangeVar);	
+ 				temp_partition->partName->relname = childTableName->data;
+ 			}
+ 			else
+ 			{
+ 	            if(isSystemGeneratedName == 0)
+ 				{
+ 					/* Assign the child table name. */        
+    		    	    childStmt->relation->relname = temp_partition->partName->relname;
+ 					isUserGeneratedName = 1;
+ 				}
+ 				else
+ 					elog(ERROR, "Combination of user generated and system generated table names is not allowed.");				
+ 			}
+     		
+ 			/* Assign the tablespace specified.  */
+ 			childStmt->tablespacename = temp_partition->tablespacename;
+ 
+ 			/* Define the relation. */
+ 			childOid = DefineRelation(childStmt, RELKIND_RELATION);
+ 
+ 		    rel = RelationIdGetRelation(childOid);
+ 		    resetStringInfo(createTrigger);
+ 		    appendStringInfo(createTrigger, "CREATE TRIGGER zz_partition_update_trigger BEFORE UPDATE ON %s ", RelationGetRelationName(rel));
+ 		    appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_update_trigger ();");
+ 		    relation_close(rel, 0);
+ 
+ 		    /* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+ 		    query_list  = pg_parse_query(createTrigger->data);
+ 		    parsetree = (Node *)lfirst(list_head(query_list));
+ 		    CreateTrigger((CreateTrigStmt * )parsetree, 0);
+ 
+ 			/* Store the Child table Oids for later use. */
+ 			partitionRelOids[i++] = childOid;
+ 		}
+         /*
+        	 * Make the changes carried out so far, visible
+          */
+         CreatePartitionTrigger(stmt, parentRelId, partitionRelOids);
+         CommandCounterIncrement();
+ 
+ 		/* Free the storage. */
+ 		free(partitionRelOids);		
+ 
+ 	}
+ 	else if(partAttr->partFunc == PART_HASH)
+ 	{
+ 
+ 		bool 		typbyval;
+ 	    Datum 		values[Natts_pg_partition];
+ 	    bool  		nulls [Natts_pg_partition];
+ 		int16		len, k;
+ 		Oid 		typ_oid;
+ 
+ 		Assert(partAttr->numberOfPartitions > 0);
+ 
+ 		i = 0;
+ 		j = 0;
+ 			
+ 		/* Allocate the storage for number of partitions.*/
+ 		partitionRelOids = malloc(sizeof(Oid) * partAttr->numberOfPartitions);
+ 
+ 		for(i=0; i<partAttr->numberOfPartitions; i++)
+ 		{
+    	        childStmt = (CreateStmt *)copyObject((void *)stmt);
+        	    childStmt->constraints = NULL;
+ 
+             /*
+    	         * Child has to use all columns from the parent, otherwise we will get
+        	     * unnecessary merging columns notices as part of the
+            	 * DefineRelation
+              */	
+    	        childStmt->tableElts = NIL;
+        	    childStmt->inhRelations = lappend(NULL, &inr);
+ 
+ 			/* Device the name of child table. */
+ 			resetStringInfo(childTableName);
+ 			appendStringInfo(childTableName, "%s_%d", stmt->relation->relname, i);
+ 
+ 			/* Use this name to create child table. */
+    	        childStmt->relation->relname = childTableName->data;
+        	    childOid = DefineRelation(childStmt, RELKIND_RELATION);
+ 	
+ 			/* */	
+ 			rel = RelationIdGetRelation(childOid);
+ 			resetStringInfo(createTrigger);
+ 			appendStringInfo(createTrigger, "CREATE TRIGGER zz_partition_update_trigger BEFORE UPDATE ON %s ", RelationGetRelationName(rel));
+ 			appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_update_trigger();");
+ 	
+ 	    	/* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+ 	    	query_list  = pg_parse_query(createTrigger->data);
+ 		    parsetree = (Node *)lfirst(list_head(query_list));
+     		CreateTrigger((CreateTrigStmt * )parsetree, 0);
+ 
+ 			/* To avoid tuple being updated by the current transaction, after the current scan started */
+ 			CommandCounterIncrement();
+ 
+             /* We can not create constraints for hash partitions directly. Instead, we will monitor inserts using insert triggers.*/
+             resetStringInfo(createTrigger);
+             appendStringInfo(createTrigger, "CREATE TRIGGER zz_partition_constraints_hash BEFORE INSERT ON %s ", RelationGetRelationName(rel));
+             appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_constraints_hash();");
+             relation_close(rel, 0);
+ 
+             /* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+             query_list  = pg_parse_query(createTrigger->data);
+             parsetree = (Node *)lfirst(list_head(query_list));
+             CreateTrigger((CreateTrigStmt * )parsetree, 0);
+ 
+ 			k = 1;
+ 
+ 			foreach(partColumn, partColumnList)
+ 			{
+ 				/* Get the name of partition key column. */
+ 				char *colName = ((Alias *)lfirst(partColumn))->aliasname;
+ 
+ 				/* Get the attribute type. */
+ 				typ_oid = get_atttype(parentRelId, get_attnum(parentRelId, colName));
+ 			
+ 				/* Get the attribute length*/
+ 				get_typlenbyval(typ_oid, &len, &typbyval);
+ 
+ 				/* initialize nulls and values */
+ 			    for (j = 0; j < Natts_pg_partition; j++)
+ 				{
+ 					nulls[j] = false;
+ 					values[j] = (Datum) NULL;
+ 				}				
+ 
+ 			    values[Anum_pg_partition_minval     -1] = Int8GetDatum(NULL);
+ 				nulls[Anum_pg_partition_minval     -1] = true;
+ 		    	values[Anum_pg_partition_maxval     -1] = Int8GetDatum(NULL);
+ 				nulls[Anum_pg_partition_maxval     -1] = true;
+ 			    values[Anum_pg_partition_parentrelid -1]= ObjectIdGetDatum(parentRelId);
+ 			    values[Anum_pg_partition_partrelid  -1] = ObjectIdGetDatum(childOid);
+ 		    	values[Anum_pg_partition_parttype   -1] = Int8GetDatum(PART_HASH);
+ 			    values[Anum_pg_partition_partkey    -1] = ObjectIdGetDatum(get_attnum(parentRelId, colName));
+ 			    values[Anum_pg_partition_listval    -1] = Int8GetDatum(NULL);
+ 			    nulls[Anum_pg_partition_listval     -1] = true;
+ 		    	values[Anum_pg_partition_hashval    -1] = Int8GetDatum(i);
+ 			    values[Anum_pg_partition_keytype    -1] = ObjectIdGetDatum(typ_oid);
+ 				values[Anum_pg_partition_keyorder   -1] = Int8GetDatum(k);
+ 
+ 				k++;
+ 
+ 			    Relation r = heap_open(PartitionRelationId, RowExclusiveLock);
+ 			    TupleDesc tupDesc = r->rd_att;
+ 	
+ 			    HeapTuple tup = heap_form_tuple(tupDesc, values, nulls);
+ 			    simple_heap_insert(r, tup);
+ 
+ 				CatalogUpdateIndexes(r, tup); 
+ 
+ 			    heap_close(r, RowExclusiveLock);
+ 			}
+ 		}
+ 
+ 		rel = RelationIdGetRelation(parentRelId);
+ 		resetStringInfo(createTrigger);
+ 		appendStringInfo(createTrigger, "CREATE TRIGGER zz_partition_insert_trigger_hash BEFORE INSERT ON %s ", RelationGetRelationName(rel));
+ 		appendStringInfo(createTrigger, " FOR EACH ROW EXECUTE PROCEDURE partition_insert_trigger_hash();");
+ 		relation_close(rel, 0);
+ 	
+ 	    /* Parse the above SQL string and use this parsetree to create trigger on parent table. */
+     	query_list  = pg_parse_query(createTrigger->data);
+ 	    parsetree = (Node *)lfirst(list_head(query_list));
+     	CreateTrigger((CreateTrigStmt * )parsetree, 0);
+ 
+         /*
+          * Make the changes carried out so far, visible
+          */
+         CreatePartitionTrigger(stmt, parentRelId, partitionRelOids);
+         CommandCounterIncrement();
+ 		
+ 		/* Free the storage. */
+ 		free(partitionRelOids);		
+ 	}
+ 	else
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
+ 				 errmsg("Invalid PARTITION type specified")));
+ }
+ 
+ /*
+  * ------------------------------------------------------------------------------
+  * ValidateRanges : Check for the intersecting ranges of specified partitions.
+  * 
+  * ------------------------------------------------------------------------------
+  */
+ int ValidateRanges(PartitionAttrs *partAttr, Oid parentRelOid, Oid *partitionRelOids)
+ {
+ 	List			*partitionList;
+ 	List			*partitionColumnList;
+ 	ListCell		*p1;
+ 	ListCell		*p2;
+ 	Partition		*partition1, *partition2;
+ 	ListCell		*partitionColumn;
+ 	ListCell		*p1MinIndex, *p1MaxIndex, *p2MinIndex, *p2MaxIndex;
+ 	Datum			p1MinDatum, p1MaxDatum, p2MinDatum;
+ 	int				i, j, k;
+ 	Oid				typ_oid;
+ 	RegProcedure	procLessThan, procGreaterThan;
+ 	Oid				LessThanOid, GreaterThanOid;
+ 	bool			isDef;
+ 
+ 
+ 	i = 0;
+ 
+ 	/* Get the partition List. */
+ 	partitionList = partAttr->partitions;
+ 
+ 	/* Get the partition-key column list*/
+ 	partitionColumnList = partAttr->colName;
+ 
+ 	foreach(partitionColumn, partitionColumnList)
+ 	{		
+ 		char *colName = ((Alias *)lfirst(partitionColumn))->aliasname;
+ 		/* Get the column type. */
+ 		typ_oid = get_atttype(parentRelOid, get_attnum(parentRelOid, colName));
+ 
+ 		foreach(p1, partitionList)
+ 		{
+ 			partition1 = lfirst(p1);
+ 			j = 0;			
+ 			p1MinIndex = partition1->partitionCheck->min_value->head;
+ 			p1MaxIndex = partition1->partitionCheck->max_value->head;
+ 
+ 			while(j < i)
+ 			{
+     	        p1MinIndex = p1MinIndex->next;
+    	    	    p1MaxIndex = p1MaxIndex->next;
+ 				j++;
+ 			}
+ 
+    	        /* If it's a FuncExpr then execute the conversion function. */
+        	    if IsA((Node *)lfirst(p1MinIndex), FuncExpr)
+            	{
+                	p1MinDatum = OidFunctionCall1(((FuncExpr *)lfirst(p1MinIndex))->funcid,
+                    	            ((Const *)((FuncExpr *)lfirst(p1MinIndex))->args->head->data.ptr_value)->constvalue);
+             }
+    	        else
+        	    {
+            	    p1MinDatum = ((Const *)lfirst(p1MinIndex))->constvalue;
+             }
+ 
+            /* If it's a FuncExpr then execute the conversion function. */
+    	        if IsA((Node *)lfirst(p1MaxIndex), FuncExpr)
+        	    {
+                	p1MaxDatum = OidFunctionCall1(((FuncExpr *)lfirst(p1MaxIndex))->funcid,
+            	                    ((Const *)((FuncExpr *)lfirst(p1MaxIndex))->args->head->data.ptr_value)->constvalue);
+        	    }
+    	        else
+             {
+            	    p1MaxDatum = ((Const *)lfirst(p1MaxIndex))->constvalue;
+        	    }
+ 
+ 			foreach(p2, partitionList)
+ 			{
+ 				if(p1 != p2)
+ 				{
+ 					partition2 = lfirst(p2);
+ 					k = 0;
+ 	                p2MinIndex = partition2->partitionCheck->min_value->head;
+         	        p2MaxIndex = partition2->partitionCheck->max_value->head;
+ 
+ 					while(k < i)
+ 					{
+                 	    p2MinIndex = p2MinIndex->next;
+             	        p2MaxIndex = p2MaxIndex->next;
+ 						k++;
+ 					}
+ 
+ 		            /* If it's a FuncExpr then execute the conversion function. */
+ 	            	if IsA((Node *)lfirst(p2MinIndex), FuncExpr)
+     	    	    {
+         		        p2MinDatum = OidFunctionCall1(((FuncExpr *)lfirst(p2MinIndex))->funcid,
+     	        	                    ((Const *)((FuncExpr *)lfirst(p2MinIndex))->args->head->data.ptr_value)->constvalue);
+ 		            }
+     	        	else
+         		    {
+         	    	    p2MinDatum = ((Const *)lfirst(p2MinIndex))->constvalue;
+ 		            }
+ 
+ 		            LessThanOid = OperatorGet("<=", PG_CATALOG_NAMESPACE , typ_oid, typ_oid, &isDef);		
+ 
+ 	        	    if(isDef == FALSE)
+     		            elog(ERROR, "'<=' operator is not defined for type '%d'.", typ_oid);
+ 
+ 					procLessThan = get_opcode(LessThanOid);
+ 	            	
+ 					GreaterThanOid = OperatorGet(">", PG_CATALOG_NAMESPACE , typ_oid, typ_oid, &isDef);
+ 	        	    
+ 					if(isDef == FALSE)
+     		            elog(ERROR, "'>' operator is not defined for type '%d'.", typ_oid);
+ 
+     	        	procGreaterThan = get_opcode(GreaterThanOid);
+ 					bool tmp1, tmp2;
+ 
+ 					tmp1 = DatumGetBool(OidFunctionCall2(procLessThan, p1MinDatum, p2MinDatum));
+ 					tmp2 = DatumGetBool(OidFunctionCall2(procGreaterThan, p1MaxDatum, p2MinDatum));
+ 
+ 	    	        if(tmp1 == true && tmp2 == true )
+ 	            	{
+ 							elog(ERROR, "Partition ranges of '%s' and '%s' are overlapping for '%s' attribute.", 
+ 									partition1->partName->relname, partition2->partName->relname, colName);
+ 					}
+ 				}
+ 			}
+ 		}
+ 		i++;
+ 	}
+ 	return 0;
+ }
+ 
+ /*
+  * ------------------------------------------------------------------------------
+  * CreatePartitionTrigger : Create trigger for insert, update. Add constraints
+  * on child tables as per ranges specified.
+  * Param 1 : CreateStmt *stmt - Pointer to struct CreateStmt which contains 
+  * 								information required to create trigger.
+  * ------------------------------------------------------------------------------
+  */
+ static void 
+ CreatePartitionTrigger(CreateStmt *stmt, Oid parentRelOid, Oid *partitionRelOids)
+ {
+ 	int				counter, numberOfPartitions;
+ 	PartitionAttrs	*partAttr;
+ 	char            *partitionColumn; 
+ 	StringInfo		func_insert = makeStringInfo();
+ 	StringInfo		func_update = makeStringInfo();
+     Partition   	*temp_partition;
+ 	List            *partitionList;
+ 	ListCell        *temp_part;
+ 	int 			partitionColumnType;
+ 	List			*partColumnList;
+ 	ListCell		*partColumn;
+ 	int 			count, i, j, l;
+ 	List			*columnList;
+ 	ListCell		*column;
+ 	int 			*partKeyOrder;
+ 
+ 	partAttr = (PartitionAttrs *)(stmt->partAttr);
+ 
+     if(partAttr->partFunc == PART_HASH)
+     {
+         return ;
+     }
+ 
+     /* Reset the buffers used.  */
+     resetStringInfo(func_insert);
+     resetStringInfo(func_update);
+ 
+ 	/* Reset */
+ 	counter 			= 0;
+ 	numberOfPartitions 	= 0;
+ 	i					= 0;
+ 	j					= 0;
+ 	l					= 0;
+ 	
+ 	partitionList = partAttr->partitions;
+ 	Assert(list_length(partitionList));
+ 
+ 	/* Get the list of partition key columns. */
+ 	partColumnList = partAttr->colName;
+ 
+ 	partKeyOrder = malloc(partColumnList->length * sizeof(int));
+ 
+ 	columnList 	= stmt->tableElts;
+ 
+ 	foreach(partColumn, partColumnList)
+ 	{
+ 		/* Get the name of partition key column. */
+ 		char 	*colName = ((Alias *)lfirst(partColumn))->aliasname;
+ 		bool 	found = false;
+ 		count = 0;
+ 
+ 		foreach(column, columnList)
+ 		{
+ 			ColumnDef *tmp = lfirst(column);
+ 			count++;
+ 			if(strcmp(tmp->colname, colName) == 0)
+ 			{
+ 				partKeyOrder[j++] = count;
+ 				found = true;
+ 				break;
+ 			}
+ 		}
+ 
+ 		if(found == false)
+ 			elog(ERROR, "'%s' attribute is not present in given table.", colName);
+ 
+ 	}
+ 
+ 	foreach(temp_part, partitionList)
+ 	{
+ 		ListCell 	*minIndex, *maxIndex;
+ 
+ 		temp_partition = lfirst(temp_part);
+ 
+ 		if ( partAttr->partFunc == PART_RANGE )
+ 		{
+ 			minIndex = temp_partition->partitionCheck->min_value->head;
+ 			maxIndex = temp_partition->partitionCheck->max_value->head;
+ 		}
+ 
+ 		j = 0;
+ 	
+ 		foreach(partColumn, partColumnList)
+ 		{
+ 
+ 			/* Get the name of partition key column. */
+ 			char *colName = ((Alias *)lfirst(partColumn))->aliasname;
+ 			partitionColumn = colName;
+ 	
+ 			/* Type of partition key column */
+     		partitionColumnType = get_atttype(parentRelOid, get_attnum(parentRelOid, partitionColumn)); 
+ 
+ 	        if ( partAttr->partFunc == PART_LIST )
+ 			{
+ 				elog(ERROR, "List partitions are not yet supported.");
+ 			}
+ 			else
+ 			{		
+ 				Datum 			min_datum, max_datum;
+ 				Oid 			typ_oid;
+ 				bool 			typbyval;
+ 				int16			len;
+ 			
+ 				/* Get the attribute type. */
+ 				typ_oid = get_atttype(parentRelOid, get_attnum(parentRelOid, partitionColumn));
+ 	
+ 				IsValidRange(minIndex, maxIndex, parentRelOid, partitionColumn, temp_partition->partName->relname);	
+ 
+ 				AddCheckConstraint(typ_oid, 
+ 					((Const *)lfirst(minIndex))->constvalue, 
+ 					((Const *)lfirst(maxIndex))->constvalue, 
+ 					 temp_partition->partName->relname, 
+ 					partitionColumn);	
+ 
+ 				/* Get the attribute length*/
+ 				get_typlenbyval(typ_oid, &len, &typbyval);
+ 
+ 				min_datum = ((Const *)lfirst(minIndex))->constvalue;
+ 				max_datum = ((Const *)lfirst(maxIndex))->constvalue;
+ 
+ 				minIndex = minIndex->next;
+ 				maxIndex = maxIndex->next;
+ 
+ 		        WriteRangePartitionToCatalog(min_datum,
+     		                                    max_datum,
+         		                                len,
+             		                            typbyval,
+                 		                        parentRelOid,
+                     		                    partitionRelOids[l],
+                         		                get_attnum(parentRelOid, partitionColumn),
+                             		            typ_oid,
+                                 		        ++j);
+ 			}	
+ 		}
+ 		l = l + 1;
+ 	}
+ 	if ( partAttr->partFunc == PART_RANGE )
+ 		ValidateRanges(partAttr,parentRelOid, partitionRelOids);
+ 	return;
+ }
+ 
+ /*
+  * Pass either "*OLD*" or "*NEW*" as appropriate depending on the trigger to
+  * to be generated
+  */
+ static void 
+ MutateColumnRefs(Node *node, char *reference) 
+ {
+ 	if IsA(node, A_Expr) 
+ 	{
+ 		MutateColumnRefs( ((A_Expr *) node)->lexpr, reference );
+ 		MutateColumnRefs( ((A_Expr *) node)->rexpr, reference);
+ 	} 
+ 	else if IsA(node, ColumnRef) 
+ 	{
+ 		ColumnRef *col_ref = (ColumnRef *) node;
+ 
+ 		/* Should have at max one column in the column list */
+ 		Assert(1 == list_length(col_ref->fields));
+ 		
+ 		col_ref->fields = list_make2(makeString(reference),
+ 								lfirst(list_head(col_ref->fields)));
+ 
+ 	}
+ 	return;
  }
Index: src/backend/commands/trigger.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/commands/trigger.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.10.1
diff -c -r1.1.1.2 -r1.1.1.2.10.1
*** src/backend/commands/trigger.c	1 Dec 2008 09:37:46 -0000	1.1.1.2
--- src/backend/commands/trigger.c	9 Mar 2009 12:55:31 -0000	1.1.1.2.10.1
***************
*** 1730,1735 ****
--- 1730,1738 ----
  			heap_freetuple(oldtuple);
  		if (newtuple == NULL)
  			break;
+ 		/* Break free from the loop is found dummy-tuple. */
+ 		if (newtuple->t_len == -1)
+ 			break;
  	}
  	return newtuple;
  }
***************
*** 2021,2026 ****
--- 2024,2032 ----
  		if (oldtuple != newtuple && oldtuple != intuple)
  			heap_freetuple(oldtuple);
  		if (newtuple == NULL)
+ 			break;
+ 		/* Break free from the loop is found dummy-tuple. */
+ 		if (newtuple->t_len == -1)
  			break;
  	}
  	heap_freetuple(trigtuple);
Index: src/backend/executor/execMain.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/executor/execMain.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.8.1
diff -c -r1.1.1.2 -r1.1.1.2.8.1
*** src/backend/executor/execMain.c	1 Dec 2008 09:37:46 -0000	1.1.1.2
--- src/backend/executor/execMain.c	9 Mar 2009 12:55:31 -0000	1.1.1.2.8.1
***************
*** 1674,1679 ****
--- 1674,1687 ----
  		if (newtuple == NULL)	/* "do nothing" */
  			return;
  
+ 		/* Check for dummy tuple */
+ 		if(newtuple->t_len == -1)
+ 		{
+ 			/* Increase the count of processed rows. */
+ 			(estate->es_processed)++;
+ 			return;
+ 		}
+ 
  		if (newtuple != tuple)	/* modified by Trigger(s) */
  		{
  			/*
***************
*** 1911,1916 ****
--- 1919,1933 ----
  
  		if (newtuple == NULL)	/* "do nothing" */
  			return;
+ 
+ 		/* Check for dummy tuple */
+ 		if(newtuple->t_len == -1)
+ 		{
+ 			/* Increase the count of processed rows. */
+ 			(estate->es_processed)++;
+ 			heap_freetuple(newtuple);
+ 			return;
+ 		}
  
  		if (newtuple != tuple)	/* modified by Trigger(s) */
  		{
Index: src/backend/nodes/copyfuncs.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/nodes/copyfuncs.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.8.6
diff -c -r1.1.1.2 -r1.1.1.2.8.6
*** src/backend/nodes/copyfuncs.c	1 Dec 2008 09:37:46 -0000	1.1.1.2
--- src/backend/nodes/copyfuncs.c	19 Mar 2009 12:34:57 -0000	1.1.1.2.8.6
***************
*** 1513,1518 ****
--- 1513,1573 ----
  	return newnode;
  }
  
+ /*
+  * _copyPartitionAttrs
+  */
+ static PartitionAttrs *
+ _copyPartitionAttrs(PartitionAttrs *from)
+ {
+ 	PartitionAttrs *newnode = makeNode(PartitionAttrs);
+ 
+ 	COPY_SCALAR_FIELD(numberOfPartitions);
+ 	COPY_NODE_FIELD(partitions);
+ 	COPY_SCALAR_FIELD(partFunc);
+ 	COPY_NODE_FIELD(colName);
+ 
+ 	return newnode;
+ }
+ 
+ /*
+  * _copyPartition
+  */
+ static Partition *
+ _copyPartition(Partition *from)
+ {
+ 	Partition *newnode = makeNode(Partition);
+ 
+ 	COPY_NODE_FIELD(partName);
+ 	COPY_NODE_FIELD(partitionCheck);
+ 	COPY_STRING_FIELD(tablespacename);
+ 
+ 	return newnode;
+ }
+ 
+ /*
+  * _copyPartition
+  */
+ static UpdatePartitionStmt *
+ _copyUpdatePartitionStmt(UpdatePartitionStmt *from)
+ {
+ 	UpdatePartitionStmt *newnode = makeNode(UpdatePartitionStmt);
+ 
+ 	COPY_NODE_FIELD(prev);
+ 	COPY_NODE_FIELD(after);
+ 
+ 	return newnode;
+ }
+ static SplitPartitionStmt * 
+ _copySplitPartitionStmt(SplitPartitionStmt *from)
+ {
+ 	SplitPartitionStmt *newnode = makeNode(SplitPartitionStmt);
+ 
+ 	COPY_NODE_FIELD(partNames);
+ 	COPY_NODE_FIELD(splitValues);
+ 
+ 	return newnode;
+ }
+ 
  /* ****************************************************************
   *						relation.h copy functions
   *
***************
*** 2018,2023 ****
--- 2073,2081 ----
  	COPY_NODE_FIELD(keys);
  	COPY_NODE_FIELD(options);
  	COPY_STRING_FIELD(indexspace);
+ 	COPY_NODE_FIELD(min_value);
+ 	COPY_NODE_FIELD(max_value);
+ 	COPY_NODE_FIELD(partition_list_values);
  
  	return newnode;
  }
***************
*** 2325,2330 ****
--- 2383,2389 ----
  	COPY_NODE_FIELD(options);
  	COPY_SCALAR_FIELD(oncommit);
  	COPY_STRING_FIELD(tablespacename);
+ 	COPY_NODE_FIELD(partAttr);
  
  	return newnode;
  }
***************
*** 3461,3467 ****
  		case T_FromExpr:
  			retval = _copyFromExpr(from);
  			break;
! 
  			/*
  			 * RELATION NODES
  			 */
--- 3520,3537 ----
  		case T_FromExpr:
  			retval = _copyFromExpr(from);
  			break;
! 		case T_PartitionAttrs:
! 			retval = _copyPartitionAttrs(from);
! 			break;
! 		case T_Partition:
! 			retval = _copyPartition(from);
! 			break;
! 		case T_UpdatePartitionStmt:
! 			retval = _copyUpdatePartitionStmt(from);
! 			break;
! 		case T_SplitPartitionStmt:
! 			retval = _copySplitPartitionStmt(from);
! 			break;
  			/*
  			 * RELATION NODES
  			 */
Index: src/backend/nodes/equalfuncs.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/nodes/equalfuncs.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.10.2
diff -c -r1.1.1.2 -r1.1.1.2.10.2
*** src/backend/nodes/equalfuncs.c	1 Dec 2008 09:37:46 -0000	1.1.1.2
--- src/backend/nodes/equalfuncs.c	4 Mar 2009 08:30:42 -0000	1.1.1.2.10.2
***************
*** 705,710 ****
--- 705,730 ----
  	return true;
  }
  
+ static bool 
+ _equalPartitionAttrs(PartitionAttrs *a, PartitionAttrs *b)
+ {
+ 	COMPARE_SCALAR_FIELD(numberOfPartitions);
+ 	COMPARE_NODE_FIELD(partitions);
+ 	COMPARE_SCALAR_FIELD(partFunc);
+ 	COMPARE_NODE_FIELD(colName);
+ 
+ 	return true;
+ }
+ 
+ static bool 
+ _equalPartition(Partition *a, Partition *b)
+ {
+ 	COMPARE_NODE_FIELD(partName);
+ 	COMPARE_NODE_FIELD(partitionCheck);
+ 
+ 	return true;
+ }
+ 
  
  /*
   * Stuff from relation.h
***************
*** 1060,1065 ****
--- 1080,1086 ----
  	COMPARE_NODE_FIELD(options);
  	COMPARE_SCALAR_FIELD(oncommit);
  	COMPARE_STRING_FIELD(tablespacename);
+ 	COMPARE_NODE_FIELD(partAttr);
  
  	return true;
  }
***************
*** 2311,2316 ****
--- 2332,2343 ----
  			break;
  		case T_JoinExpr:
  			retval = _equalJoinExpr(a, b);
+ 			break;
+ 		case T_PartitionAttrs:
+ 			retval = _equalPartitionAttrs(a, b);
+ 			break;
+ 		case T_Partition:
+ 			retval = _equalPartition(a, b);
  			break;
  
  			/*
